#!/usr/bin/env python3
# -*- coding: utf-8 -*-

'''
Created on 2016年3月20日
@author: zk
'''

# import modules
import ogr, os, sys, psycopg2
from PIL import Image,ImageDraw
from pyproj import Proj

#set server info
hosti='localhost'
porti=5432
useri='postgres'
pwdi='postgres'
dbi='postgis'

# set the working directory
os.chdir('/home/zk/桌面/CHN_adm')

#connect the server
conn = psycopg2.connect(host=hosti, port=porti, user=useri, password=pwdi,database=dbi)
cur = conn.cursor()
 
#draw shp on an image
def drawPolygon(geom, draw, w, h, minlng, maxlng, minlat, maxlat):
    for j in range(0, geom.GetGeometryCount()):
        item = geom.GetGeometryRef(j)
	#中国全国范围内的Albers投影
        p=Proj('+proj=aea +lon_0=105 +lat_1=25 +lat_2=47 +ellps=krass') 
        for i in range(0, item.GetPointCount()-2):
            p1 = item.GetPoint(i)
            x1,y1 = p(p1[0],p1[1])
            p1=[w*(x1-minlng)/(maxlng-minlng),h-h*(y1-minlat)/(maxlat-minlat)]
            p2 = item.GetPoint(i + 1)
            x2,y2 = p(p2[0],p2[1])
            p2=[w*(x2-minlng)/(maxlng-minlng),h-h*(y2-minlat)/(maxlat-minlat)]
            draw.line(p1 + p2, fill=128)
        p1 = item.GetPoint(item.GetPointCount()-1)
        x1,y1 = p(p1[0],p1[1])
        p1=[w*(x1-minlng)/(maxlng-minlng),h-h*(y1-minlat)/(maxlat-minlat)]
        p2 = item.GetPoint(0)
        x2,y2 = p(p2[0],p2[1])
        p2=[w*(x2-minlng)/(maxlng-minlng),h-h*(y2-minlat)/(maxlat-minlat)]
        draw.line(p1 + p2, fill=128)
    return

#create the image
cur.execute("SELECT ST_XMin(bbox.geom), ST_XMax(bbox.geom), ST_YMin(bbox.geom), ST_YMax(bbox.geom) FROM (SELECT ST_Envelope(ST_Union(geom)) AS geom FROM public.CHN_adm0) AS bbox")
bbox = cur.fetchone()
min_lng = bbox[0]
max_lng = bbox[1]
min_lat = bbox[2]
max_lat = bbox[3]
print(min_lng,min_lat,max_lng,max_lat)
#中国全国范围内的Albers投影
p1=Proj('+proj=aea +lon_0=105 +lat_1=25 +lat_2=47 +ellps=krass') 
minlng,minlat = p1(min_lng,min_lat);
maxlng,maxlat = p1(max_lng,max_lat);
print(minlng,minlat,maxlng,maxlat)
w = 1280
h = int(w * (maxlat - minlat) / (maxlng - minlng))
img = Image.new("RGB", (w, h), "white")
draw = ImageDraw.Draw(img)
#draw geometry
cur.execute('select gid,ST_AsText(geom) AS geom from public.CHN_adm0;')
shp=cur.fetchall()
for row in shp:
    # print row[1]
    ob = ogr.CreateGeometryFromWkt(row[1])
    gtype=ob.GetGeometryName()
    #print(gtype)
    if gtype=='MULTIPOLYGON':
        for j in range(0, ob.GetGeometryCount()):
                item = ob.GetGeometryRef(j)
                drawPolygon(item, draw, w, h, minlng, maxlng, minlat, maxlat)
    else:
        drawPolygon(ob, draw, w, h, minlng, maxlng, minlat, maxlat)
#save image

img.show()
img.save('China0.jpg', 'JPEG')
print('Draw shp successfully!')
cur.close()
conn.close()


#===============================================================================
# # get the attributes in this layer
# layerDefn = layer.GetLayerDefn()
# for i in range(layerDefn.GetFieldCount()):
#     fieldName=layerDefn.GetFieldDefn(i).GetNameRef()
#     fieldType=layerDefn.GetFieldDefn(i).GetType()
#===============================================================================



#if __name__=='__main__':
    

